// Test polimorphic functions more!
// $Id: neat.g,v 1.5 2002/05/27 15:08:48 malekith Exp $

/* Takes multiplication function, and one element. Returns power function,
 * with Time = O(log n). */
*('a ('a, int)) pow(*('a ('a, 'a)) mul, 'a one)
{
	'a f('a val, int n) {
		if (n == 0)
			return one;
			
		if (n == 1)
			return val;
		
		'a res = f(val, n / 2);

		res = mul(res, res);
		
		if (n % 2 == 1)
			res = mul(res, val);

		return res;
	}

	return f;
}


section init
{
	int int_mul(int x, int y) (x * y)
	
	/* First we make integer power function: */
	*(int (int, int)) int_pow = pow(int_mul, 1);

	/* and test it! */
	print_string("2 ^ 12 = ");
	print_int(int_pow(2, 12));
	print_string(", ");
	print_string("6 ^ 6 = ");
	print_int(int_pow(6, 6));
	print_string(", ");
	
	/* Now the funny part: */
	
	/* Return function, that applaies f n times. */
	*('a ('a)) f_power_1(*('a ('a)) f, int n)
	{
		/* In case of 0, return id function. */
		if (n == 0)
			return fun 'a ('a x) (x);
			
		if (n == 1) {
			return f;
		} else {
			return fun 'a ('a x) (f((f_power_1(f, n - 1))(x)));
		}
	}

	/* But ain't happy with f_power_1 -- it takes O(n) time and
	 * space. Try use pow() function. */
	*('a ('a)) combine(*('a ('a)) f, *('a ('a)) g)
	{
		return fun 'a ('a x) (f(g(x)));
	}

	*(*('a ('a)) (*('a ('a)), int)) f_power_2;

	f_power_2 = pow(combine, fun 'a ('a x) (x));

	/* And test it! */
	*(int (int)) add_one = fun int (int x) (x + 1);
	*(int (int)) add5_1 = f_power_1(add_one, 5);
	*(int (int)) add5_2 = f_power_2(add_one, 5);

	print_string("add5(10) = ");
	print_int(add5_1(10));
	print_string(" = ");
	print_int(add5_2(10));
	print_string("\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 2 ^ 12 = 4096, 6 ^ 6 = 46656, add5(10) = 15 = 15
 */
